.TH tt   "12 August 2019"
.SH tt
tt \- measures the running time of the selected 
.B application 
.SH DESCRIPTION
Main aim of
.B tt
is to run chosen 
.B application 
serially, several times and measure running time. For this
.B application 
is given by absolute
.I path
using option '-b' and  
.I amount
of repeatings is given by option '-c'. For each run, it is possible to save a separate
execution time. For the entire series the maximum and minimum time, average time, variance and standard
deviation are calculated. Time is measured using 7 standard functions: clock_gettime, time, clock, gettimeofday, timespec_get,
times, getrusage. If defined _POSIX_TIMERS, then 
.B tt
for clock_gettime function selects CLOCK with
lowest available resolution in first place.
.SH SYNOPSIS
.SY \fBtt\fP
.OP \-arqgtomspHfM
.OP \-S \fIseconds\fP
.OP \-b \fIpath\fP  [@application options@] 
.OP \-c \fIamount\fP
.SY \fBtt\fP
.OP \-R
.OP \-d
.OP \-V
.OP \-h
.YS 
.SS Options
.TP
\fB-a\fP
for second clock_gettime selects CLOCK_PROCESS_CPUTIME_ID. 
.TP
\fB-r\fP
includes function getrusage.
.TP
\fB-q\fP
quiet - hides standard output for
.B application.
.TP
\fB-g\fP
includes function gettimeofday.
.TP
\fB-t\fP
includes function times.
.TP
\fB-o\fP
includes function clock.
.TP
\fB-m\fP
includes function time.
.TP
\fB-s\fP
includes function timespec_get.
.TP
\fB-p\fP
force posix_spawn to run \fBapplication\fP, by default is used fork/exec.
.TP
\fB-H\fP
hide intermediate results for each, 
.B application
run, implies \-M.
.TP
\fB-f\fP
prints to file \(lqtt_results.txt\(rq in current directory.
.TP
\fB-M\fP
not keep intermediate results.
.TP
\fB-S\fP \fIseconds\fP
sleep \fIseconds\fP between each iteration.
.TP
\fB-b \fIpath\fP
absolute
.I path
for
.B application. 
It is possible to specify command line options also for the 
.B application 
using OPTS_DELIM variable during configuration. By default it is '@', but can be changed to any other desirable symbol. For example: ./configure OPTS_DELIM="\\&". Also can be used OPTS_DELIM='\\&'  or  OPTS_DELIM=\\'\\&\\' forms. See examples.
.TP
\fB-c \fIamount\fR
run 
.B application
\fIamount\fR times.
.TP
\fB-R\fP
show resolution for some clocks.
.TP
\fB-d\fP
show size limits for some types.
.TP
\fB-V\fP
Version.
.TP
\fB-h\fP
help.
.SH OTHER
It is possible to save intermediate results either in the 
.B tt
stack or in the heap. By default 
.B tt
use stack. For heap, before compiling, it should be configured with option --enable-MEMORY.
Source is prepared for translation using gettext. For translation .mo files can be chosen directory by using variable LDIR during configuration. For example: ./configure LDIR=/home/user/tt/po/ , if not defined "/usr/share/locale" will be used.
.SH AUTHOR/REPORTING BUGS
zkutch@yahoo.com
.SH COPYRIGHT
MIT License
.SH EXAMPLES
\fC\fR
.SS tt  -b /usr/bin/find -c 30 -q -a -S 1 -m -t -g -r -s -o
\FP
.br
runs
.B application
find in current directory 30 times, hide standard output for it, use second clock_gettime, time, times, gettimeofday, getrusage, timespec_get and clock functions for measuring time. Sleep 1 second between each run.
\fC\fR
.SS tt  -b /bin/ls @-l -h@ -c 100 -q -a -S 2 -m -t -g -r -s -o
\FP
.br
runs
.B application
ls in current directory 100 times with options "-l -h", hide standard output for it, use second clock_gettime, time, times, gettimeofday, getrusage, timespec_get and clock functions for measuring time. Sleep 2 seconds between each run. As mentioned,  it can be used other symbol in place of '@'. If, for example, '&' is chosen, then it should be used with escape symbol:
\fC\fR
.SS tt  -b /bin/ls \\&-l -h\\& -c 100 -q -a -S 2 -m -t -g -r -s -o
\FP
.SH "SEE ALSO"
time(1)
.SH BUGS
Yet none known.
